<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/Form.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/Form.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
define(['underscore', 'jquery', 'uweaver/lang',
    'uweaver/widget/Widget', 'uweaver/data/Model', 'uweaver/widget/Textbox', 'uweaver/widget/Numberbox',
    'uweaver/widget/Datebox', 'uweaver/widget/Checkbox', 'uweaver/widget/Radiobutton', 'uweaver/widget/Selectbox',
    'uweaver/widget/Combobox', 'uweaver/widget/Filedropper',
    'uweaver/widget/Filebox'], function (_, $, lang, Widget, Model, Textbox, Numberbox, Datebox, Checkbox,
                                             Radiobutton, Selectbox, Combobox, Filedropper, Filebox) {
    var declare = lang.declare;
    var Base = Widget;


    /**
     * A Form is a container containing form controls, such as Inputbox, Selectbox, Listbox and so on.
     *
     * ##### JavaScript
     *
     *     var Product = declare(Model, {
     *          resource: 'products'
     *     });
     *
     *     var item = new Product({_id: "_rose"});
     *
     *     var form = new Form({
     *         el: $('#form'),
     *         data: item
     *     });
     *     form.render();
     *
     *     item.fetch({async: false});
     *
     *     var priceControl = form.control('price')
     *     expect(priceControl.value()).to.equal(item.get('price'));
     *
     *     item.set('price', 4.8);
     *     expect(priceControl.value()).to.equal(item.get('price'));
     *
     *     priceControl.value(9.6);
     *     expect(priceControl.value()).to.equal(item.get('price'));
     *
     *
     * ##### HTML
     *     &lt;!-- the following dom are required.
     *     + form - the DOM element.
     *     -->
     *     &lt;form id="form" class="container form-horizontal">
     *         &lt;label class="control-label col-sm-1 gutter">Name&lt;/label>
     *         &lt;div class="col-sm-3 gutter">
     *             &lt;input name="name" class="form-control" placeholder="Product Name">
     *         &lt;/div>
     *         &lt;label class="control-label col-sm-1 gutter">Price&lt;/label>
     *         &lt;div class="col-sm-3 gutter">
     *             &lt;input name="price" type="number" class="form-control" placeholder="Unit Price">
     *         &lt;/div>
     *     &lt;/form>
     *
     * ##### Events:
     * + 'change' - [value()]{@link Form#value}, [values()]{@link Form#values}
     *
     * @constructor Form
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * ##### Options:
     * + tpl:String - A html string to layout &amp; construct the DOM element. Optional.
     * + data:Model - Thd data source. Optional.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);
        
        var defaults = {};
        var cfg = this._cfg;

        _.defaults(cfg, defaults);

        this._anchors = {};
        this._controls = [];
        this._disabled = {};

        (cfg.data) ? this.data(cfg.data) : this.data(new Model());
    }

    /**
     * @override
     */
    function render(options) {
        Base.prototype.render.apply(this, arguments);

        var defaults = {
            hidden: false
        };
        var cfg = this._cfg;
        var anchors = this._anchors;

        options || (options = {});
        _.defaults(options, defaults);

        clean.call(this);

        var controls = this._controls;

        // textbox
        var $textboxes = this.$('input[type=text][name], input[type=password][name], textarea[name]');
        _.each($textboxes, function(element) {
            var $textbox = $(element);
            var textbox = new Textbox({
                el: $textbox
            });
            textbox.render();
            this.listenTo(textbox, 'change', _.bind(onControlChange, this));
            controls.push(textbox);
        }, this);


        // numberbox
        var $numberboxes = this.$('input[type=number][name]');
        _.each($numberboxes, function(element) {
            var $numberbox = $(element);
            var numberbox = new Numberbox({
                el: $numberbox
            });
            numberbox.render();
            this.listenTo(numberbox, 'change', _.bind(onControlChange, this));
            controls.push(numberbox);
        }, this);

        // datebox
        var $dateboxes = this.$('input[type=date][name], input[type=datetime-local][name], input[type=month][name]');
        _.each($dateboxes, function(element) {
            var $datebox = $(element);
            var datebox = new Datebox({
                el: $datebox
            });
            datebox.render();
            this.listenTo(datebox, 'change', _.bind(onControlChange, this));
            controls.push(datebox);
        }, this);


        // checkbox
        var $checkboxes = this.$('input[type=checkbox][name]');
        _.each($checkboxes, function(element) {
            var $checkbox = $(element);
            var checkbox = new Checkbox({
                el: $checkbox
            });
            checkbox.render();
            this.listenTo(checkbox, 'change', _.bind(onControlChange, this));
            controls.push(checkbox);
        }, this);

        // radiobutton
        var $radiobuttons = this.$('input[type=radio][name]');
        _.each($radiobuttons, function(element) {
            var $radiobutton = $(element);
            var radiobutton = new Radiobutton({
                el: $radiobutton
            });
            radiobutton.render();
            this.listenTo(radiobutton, 'change', _.bind(onControlChange, this));
            controls.push(radiobutton);
        }, this);

        // selectbox
        var $selectboxes = this.$('select');
        _.each($selectboxes, function(element) {
            var $selectbox = $(element);
            var selectbox = new Selectbox({
                el: $selectbox
            });
            selectbox.render();
            this.listenTo(selectbox, 'change', _.bind(onControlChange, this));
            controls.push(selectbox);
        }, this);

        // combobox
        var $comboboxes = this.$('div[data-control=combobox][name]');
        _.each($comboboxes, function(element) {
            var $combobox = $(element);
            var combobox = new Combobox({
                el: $combobox
            });
            combobox.render();
            this.listenTo(combobox, 'change', _.bind(onControlChange, this));
            controls.push(combobox);
        }, this);

        // filedropper
        var $filedroppers = this.$('div[data-control=filedropper][name]');
        _.each($filedroppers, function(element) {
            var $filedropper = $(element);
            var filedropper = new Filedropper({
                el: $filedropper
            });
            filedropper.render();
            this.listenTo(filedropper, 'change', _.bind(onControlChange, this));
            controls.push(filedropper);
        }, this);

        // filebox
        var $fileboxes = this.$('input[type=file][name]');
        _.each($fileboxes, function(element) {
            var $filebox = $(element);
            var filebox = new Filebox({
                el: $filebox
            });
            filebox.render();
            this.listenTo(filebox, 'change', _.bind(onControlChange, this));
            controls.push(filebox);
        }, this);

        update.call(this, this._data.toJSON());

        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this.show();
        }

        return this;
    }


    function onControlChange(event) {
        var control = event.context;

        this.save(control.name());
    }

    /**
     * Get or set the data.
     *
     * ##### Events:
     * + 'transition' - triggered after a new model is bound. event.data => the data.
     *
     * @memberof Form#
     * @param {Model} item - the data.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * ##### Options:
     * + silent(Boolean) - A false value will prevent the events from being triggered. Default = false.
     * @returns {Form} this
     */
    function data(item, options) {
        if(!item) return this._data;

        options || (options = {});

        var defaults = {};

        _.defaults(options, defaults);

        if(this._data) this.stopListening(this._data);

        this._data = item;

        this.listenTo(this._data, "change", _.bind(onItemUpdate, this));

        this.clearValidation();

        this.isRendered() &amp;&amp; reset.call(this);

        (options.silent) || this.trigger('transition', {
            context: this,
            source: this,
            data: item
        });

        return this;
    }

    function onItemUpdate(event) {
        update.call(this, event.changedAttributes());
    }

    function controls(name) {
        var controls = this._controls;

        if(!name) return controls;

        return _.filter(controls, function(control) {
            return (control.name()===name)
        });
    }

    function control(name) {
        var controls = this._controls;

        return _.find(controls, function(control) {
            return (control.name()===name)
        });
    }

    function update(attributes) {
        var controls = this._controls;

        _.each(controls, function(control) {
            var name = control.name();
            _.has(attributes, name) &amp;&amp; (control.value(attributes[name], {silent:true}));
        });

        _.each(controls, function(control) {
            control.change();
        });
    }

    function save(name) {
        if(arguments.length===0) {
            if(!this.validate()) return;
            _.each(this._controls, function(control) {
                this.save(control.name());
            }, this);
            return;
        }

        var controls = this.controls(name);
        var value;

        if(controls.length===0) return;

        if(controls.length===1||(controls[0].type()!==controls[1].type())) {
            value = controls[0].value();
        } else {
            var values = _.reduce(controls, function(memo, control){
                control.value() &amp;&amp; memo.push(control.value());
                return memo;
            }, []);
            value = values.join(',');
            (value.length===0) &amp;&amp; (value = null);
        }

        nullify(this._data.get(name))===nullify(value) || this._data.set(name, value);
    }

    function nullify(value) {
        return (value===null||value===undefined) ? null : value;
    }

    function reset() {
        var controls = this._controls;
        var data = this._data;
        _.each(controls, function(control) {
            var name = control.name();
            control.clear();
            data.has(name) &amp;&amp; (control.value(data.get(name), {silent:true}));
        });
    }

    function clear() {
        var controls = this._controls;
        this._data.clear({silent: true});
        _.each(controls, function(control) {
            control.clear();
        });
    }

    /**
     * @override
     */
    function destroy() {
        clean.call(this);
        Base.prototype.destroy.apply(this, arguments);
    }

    function clean() {
        var controls = this._controls;
        var control;

        while(controls.length>0) {
            control = controls.shift();
            control.destroy();
        }
    }

    function checkValidity() {
        return (this.violations().length===0);
    }

    function violations() {
        var controls = this._controls;
        var violations = [];
        var index = {};
        _.each(controls, function(control) {
            if(index[control.name()]) {
                return
            } else if(control.violations()) {
                violations = violations.concat(control.violations());
                index[control.name()] = true;
            }
        });
        return violations;
    }

    function validate() {
        var controls = this._controls;
        var valid = true;
        _.each(controls, function(control) {
            control.validate() || (valid = false);
        });
        return valid;
    }

    function violate(violations) {
        _.isArray(violations) || (violations = [violations]);
        _.each(violations, function(violation) {
            var properties = violation.properties();
            _.each(properties, function(property) {
                var control = this.control(property);
                control &amp;&amp; control.violate(violation);
            }, this);
        }, this);
    }

    function clearValidation() {
        var controls = this._controls;
        _.each(controls, function(control) {
            control.clearValidation();
        });
    }

    /**
     * Get or set the state.
     *
     * ##### HTML
     *     &lt;!--
     *     + username - will become readonly in edit &amp; read state.
     *     + displayName - will become readonly in the read state.
     *     + quota - will become hidden in the add state and readonly in the read state.
     *     -->
     *
     *     &lt;form id="form" class="container form-horizontal">
     *         &lt;label class="control-label col-sm-1 gutter">Username&lt;/label>
     *         &lt;div class="col-sm-3 gutter">
     *             &lt;input name="username" class="form-control" placeholder="Username" data-readonly-state="edit,read">
     *         &lt;/div>
     *         &lt;label class="control-label col-sm-1 gutter">Display Name&lt;/label>
     *         &lt;div class="col-sm-3 gutter">
     *             &lt;input name="displayName" class="form-control" placeholder="Display Name" data-readonly-state="read">
     *         &lt;/div>
     *         &lt;label class="control-label col-sm-1 gutter">Quota&lt;/label>
     *         &lt;div class="col-sm-3 gutter">
     *             &lt;input name="quota" type="number" class="form-control" placeholder="Quota" data-hidden-state="add" data-readonly-state="read">
     *         &lt;/div>
     *     &lt;/form>
     *
     * @memberof Form#
     * @param {String} value - the state.
     * @returns {String|void}
     */
    function state(value) {
        if(arguments.length===0) return this._state;
        
        this._state = value;
        
        var controls = this._controls;
        _.each(controls, function(control) {
            control.state(value);
        });
        
    }

    function disable() {
        var controls = this._controls;
        _.each(controls, function(control) {
            this._disabled[control.oid()] = control.disabled();
            control.disabled(true);
        }, this);
    }

    function enable() {
        var controls = this._controls;
        _.each(controls, function(control) {
            _.has(this._disabled, control.oid()) &amp;&amp; control.disabled(this._disabled[control.oid()]);
        }, this);

        this._disabled = {};
    }

    var props = {
        _controls: undefined,
        _data: undefined,
        _state: undefined,
        _disabled: undefined,
        /**
         * @override
         */
        className: 'form'
    };

    var Form = declare(Base, {
        initialize: initialize,
        render: render,
        destroy: destroy,
        data: data,
        controls: controls,
        control: control,
        checkValidity: checkValidity,
        violations: violations,
        validate: validate,
        violate: violate,
        clearValidation: clearValidation,
        state: state,
        disable: disable,
        enable: enable,
        clear: clear,
        reset: reset,
        save: save
    }, props);

    return Form

});</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
